Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.functions
Interface FunctionLibrary

All Superinterfaces:
  Serializable

All Known Subinterfaces:
  XQueryFunctionBinder

All Known Implementing Classes:
  ConstructorFunctionLibrary, ExecutableFunctionLibrary, ExtraFunctionLibrary, FunctionLibraryList, ImportedFunctionLibrary, IntegratedFunctionLibrary, JavaExtensionLibrary, StylesheetFunctionLibrary, SystemFunctionLibrary, UnboundFunctionLibrary, VendorFunctionLibrary, XPathFunctionLibrary, XQueryFunctionLibrary

    public interface FunctionLibrary

extends Serializable

A FunctionLibrary handles the binding of function calls in XPath (or XQuery) expressions. There are a number of implementations of this class to handle different kinds of function: system functions, constructor functions, vendor-defined functions, Java extension functions, stylesheet functions, and so on. There is also an implementation `FunctionLibraryList` that allows a FunctionLibrary to be constructed by combining other FunctionLibrary objects.

Method Summary
`Expression` | `bind(StructuredQName functionName, Expression[] staticArgs, StaticContext env, Container container)` Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
`FunctionLibrary` | `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
`SequenceType[]` | `getFunctionSignature(StructuredQName functionName, int arity)` Test whether a function with a given name and arity is available; if so, return its signature.

Method Detail

### getFunctionSignature

    SequenceType[] getFunctionSignature(StructuredQName functionName,
                                        int arity)

  Test whether a function with a given name and arity is available; if so, return its signature. This supports the function-available() function in XSLT; it is also used to support higher-order functions introduced in XQuery 1.1.

  This method may be called either at compile time or at run time. If the function library is to be used only in an XQuery or free-standing XPath environment, this method may throw an UnsupportedOperationException.

  Parameters:
    `functionName` - the qualified name of the function being called
    `arity` - The number of arguments. This is set to -1 in the case of the single-argument function-available() function; in this case the method should return a zero-lengh array if there is some function of this name available for calling.
  Returns:
    if a function of this name and arity is available for calling, then the type signature of the function, as an array of sequence types in which the zeroth entry represents the return type; or a zero-length array if the function exists but the signature is not known; or null if the function does not exist

### bind

    Expression bind(StructuredQName functionName,
                    Expression[] staticArgs,
                    StaticContext env,
                    Container container)
                    throws XPathException

  Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.

  Parameters:
    `functionName` - the QName of the function being called
    `staticArgs` - The expressions supplied statically in arguments to the function call. The length of this array represents the arity of the function. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality()) may be used as part of the binding algorithm. In some cases it may be possible for the function to be pre-evaluated at compile time, for example if these expressions are all constant values.

    The conventions of the XPath language demand that the results of a function depend only on the values of the expressions supplied as arguments, and not on the form of those expressions. For example, the result of f(4) is expected to be the same as f(2+2). The actual expression is supplied here to enable the binding mechanism to select the most efficient possible implementation (including compile-time pre-evaluation where appropriate).

    `env` - The static context of the function call
    `container` - The container for the newly created Expression
  Returns:
    An expression equivalent to a call on the specified function, if one is found; null if no function was found matching the required name and arity.
  Throws:
    `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function.

### copy

    FunctionLibrary copy()

  This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.

  Returns:
    a copy of this function library. This must be an instance of the original class.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.